    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2007, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ---------------------
    028     * XYIntervalSeries.java
    029     * ---------------------
    030     * (C) Copyright 2006, 2007, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes
    036     * -------
    037     * 20-Oct-2006 : Version 1 (DG);
    038     * 13-Feb-2007 : Added several new accessor methods (DG);
    039     *
    040     */
    041
    042    package org.jfree.data.xy;
    043
    044    import org.jfree.data.ComparableObjectItem;
    045    import org.jfree.data.ComparableObjectSeries;
    046
    047    /**
    048     * A list of (x, x-low, x-high, y, y-low, y-high) data items.
    049     *
    050     * @since 1.0.3
    051     *
    052     * @see XYIntervalSeriesCollection
    053     */
    054    public class XYIntervalSeries extends ComparableObjectSeries {
    055
    056        /**
    057         * Creates a new empty series.  By default, items added to the series will
    058         * be sorted into ascending order by x-value, and duplicate x-values will
    059         * be allowed (these defaults can be modified with another constructor).
    060         *
    061         * @param key  the series key (<code>null</code> not permitted).
    062         */
    063        public XYIntervalSeries(Comparable key) {
    064            this(key, true, true);
    065        }
    066
    067        /**
    068         * Constructs a new xy-series that contains no data.  You can specify
    069         * whether or not duplicate x-values are allowed for the series.
    070         *
    071         * @param key  the series key (<code>null</code> not permitted).
    072         * @param autoSort  a flag that controls whether or not the items in the
    073         *                  series are sorted.
    074         * @param allowDuplicateXValues  a flag that controls whether duplicate
    075         *                               x-values are allowed.
    076         */
    077        public XYIntervalSeries(Comparable key, boolean autoSort,
    078                boolean allowDuplicateXValues) {
    079            super(key, autoSort, allowDuplicateXValues);
    080        }
    081
    082        /**
    083         * Adds a data item to the series.
    084         *
    085         * @param x  the x-value.
    086         * @param xLow  the lower bound of the x-interval.
    087         * @param xHigh  the upper bound of the x-interval.
    088         * @param y  the y-value.
    089         * @param yLow  the lower bound of the y-interval.
    090         * @param yHigh  the upper bound of the y-interval.
    091         */
    092        public void add(double x, double xLow, double xHigh, double y, double yLow,
    093                double yHigh) {
    094            super.add(new XYIntervalDataItem(x, xLow, xHigh, y, yLow, yHigh), true);
    095        }
    096
    097        /**
    098         * Returns the x-value for the specified item.
    099         *
    100         * @param index  the item index.
    101         *
    102         * @return The x-value (never <code>null</code>).
    103         */
    104        public Number getX(int index) {
    105            XYIntervalDataItem item = (XYIntervalDataItem) getDataItem(index);
    106            return item.getX();
    107        }
    108
    109        /**
    110         * Returns the lower bound of the x-interval for the specified item in the
    111         * series.
    112         *
    113         * @param index  the item index.
    114         *
    115         * @return The lower bound of the x-interval.
    116         *
    117         * @since 1.0.5
    118         */
    119        public double getXLowValue(int index) {
    120            XYIntervalDataItem item = (XYIntervalDataItem) getDataItem(index);
    121            return item.getXLowValue();
    122        }
    123
    124        /**
    125         * Returns the upper bound of the x-interval for the specified item in the
    126         * series.
    127         *
    128         * @param index  the item index.
    129         *
    130         * @return The upper bound of the x-interval.
    131         *
    132         * @since 1.0.5
    133         */
    134        public double getXHighValue(int index) {
    135            XYIntervalDataItem item = (XYIntervalDataItem) getDataItem(index);
    136            return item.getXHighValue();
    137        }
    138
    139        /**
    140         * Returns the y-value for the specified item.
    141         *
    142         * @param index  the item index.
    143         *
    144         * @return The y-value.
    145         */
    146        public double getYValue(int index) {
    147            XYIntervalDataItem item = (XYIntervalDataItem) getDataItem(index);
    148            return item.getYValue();
    149        }
    150
    151        /**
    152         * Returns the lower bound of the Y-interval for the specified item in the
    153         * series.
    154         *
    155         * @param index  the item index.
    156         *
    157         * @return The lower bound of the Y-interval.
    158         *
    159         * @since 1.0.5
    160         */
    161        public double getYLowValue(int index) {
    162            XYIntervalDataItem item = (XYIntervalDataItem) getDataItem(index);
    163            return item.getYLowValue();
    164        }
    165
    166        /**
    167         * Returns the upper bound of the y-interval for the specified item in the
    168         * series.
    169         *
    170         * @param index  the item index.
    171         *
    172         * @return The upper bound of the y-interval.
    173         *
    174         * @since 1.0.5
    175         */
    176        public double getYHighValue(int index) {
    177            XYIntervalDataItem item = (XYIntervalDataItem) getDataItem(index);
    178            return item.getYHighValue();
    179        }
    180
    181        /**
    182         * Returns the data item at the specified index.
    183         *
    184         * @param index  the item index.
    185         *
    186         * @return The data item.
    187         */
    188        public ComparableObjectItem getDataItem(int index) {
    189            return super.getDataItem(index);
    190        }
    191
    192    }